# std::tuple_size<std::pair>

From cppreference.com
< cpp‎ | utility‎ | pair

Defined in header `<utility>` |  |
template< class T1, class T2 > struct tuple_size< std::pair <T1, T2>>; |  | (since C++11) (until C++14)
template <class T1, class T2> struct tuple_size< std::pair <T1, T2>> : std::integral_constant < std::size_t, 2> { }; |  | (since C++14)

The partial specialization of std::tuple_size for pairs provides a compile-time way to obtain the number of elements in a pair, which is always 2, using tuple-like syntax.

## Inherited from std::integral_constant

### Member constants

value [static] | the constant value 2 (public static member constant)

### Member functions

operator std::size_t | converts the object to std::size_t, returns `value` (public member function)
operator() (C++14) | returns `value` (public member function)

### Member types

Type | Definition
`value_type` | `std::size_t`
`type` | std::integral_constant < std::size_t, value>

### Example

Run this code

    #include <iostream>
    #include <utility>
    #include <tuple>

    template<class T>
    void test(T t)
    {
        int a[std::tuple_size<T>::value]; // can be used at compile time
        std::cout << std::tuple_size<T>::value << '\n'; // or at run time
    }

    int main()
    {
        test(std::make_tuple(1, 2, 3.14));
        test(std::make_pair(1, 3.14));
    }

Output:

    3
    2

### See also

tuple_size | obtains the size of `tuple` at compile time (class template specialization)
std::tuple_size<std::array> | obtains the size of an `array` (class template specialization)
std::tuple_element<std::pair> (C++11) | obtains the type of the elements of `pair` (class template specialization)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/utility/pair/tuple_size&oldid=68201"